.ifndef FLOAT_H
.define FLOAT_H

DFPPREC = 6
.global dfpdump_a, con_puthex, dfpformat_a, dfpbeautify_a
.global dfpfromu8, dfpnzrange, dfpnorm
.global dfpload, dfpload0, dfpstore, dfpstore0
.global dfpmova, dfpmovb, dfpmovc, dfpmovd
.global dfphalve, dfpdouble, dfpinc
.global dfpadd, dfpsub, dfpcmp, dfpmul
.globalzp DFPREG_A, DFPREG_B, DFPREG_C, DFPREG_D

.macro dfpldr reg, arg
  .local argvalue
  ldx #reg
  .if (.match (.left (1, {arg}), #))
    argvalue = .right(.tcount({arg})-1, {arg})
    lda #argvalue
    ldy #0
    jsr dfpfromu8
  .else
    argvalue = arg
    lda #>argvalue
    ldy #<argvalue
    jsr dfpload
  .endif
.endmacro

.macro dfplda arg
  dfpldr DFPREG_A, {arg}
.endmacro

.macro dfpldb arg
  dfpldr DFPREG_B, {arg}
.endmacro

.macro dfpldc arg
  dfpldr DFPREG_C, {arg}
.endmacro

.macro dfpldd arg
  dfpldr DFPREG_D, {arg}
.endmacro

.macro dfpstr reg, arg
  .local argvalue
  argvalue = arg
  ldx #reg
  lda #>argvalue
  ldy #<argvalue
  jsr dfpstore
.endmacro

.macro dfpsta arg
  dfpstr DFPREG_A, {arg}
.endmacro

.macro dfpstb arg
  dfpstr DFPREG_B, {arg}
.endmacro

.macro dfpstc arg
  dfpstr DFPREG_C, {arg}
.endmacro

.macro dfpstd arg
  dfpstr DFPREG_D, {arg}
.endmacro

.macro dfptab
  ldx #DFPREG_B
  jsr dfpmova
.endmacro

.macro dfptac
  ldx #DFPREG_C
  jsr dfpmova
.endmacro

.macro dfptad
  ldx #DFPREG_D
  jsr dfpmova
.endmacro

.macro dfptba
  ldx #DFPREG_A
  jsr dfpmovb
.endmacro

.macro dfptbc
  ldx #DFPREG_C
  jsr dfpmovb
.endmacro

.macro dfptbd
  ldx #DFPREG_D
  jsr dfpmovb
.endmacro

.macro dfptca
  ldx #DFPREG_A
  jsr dfpmovc
.endmacro

.macro dfptcb
  ldx #DFPREG_B
  jsr dfpmovc
.endmacro

.macro dfptcd
  ldx #DFPREG_D
  jsr dfpmovc
.endmacro

.macro dfptda
  ldx #DFPREG_A
  jsr dfpmovd
.endmacro

.macro dfptdb
  ldx #DFPREG_B
  jsr dfpmovd
.endmacro

.macro dfptdc
  ldx #DFPREG_C
  jsr dfpmovd
.endmacro

.endif
